
Unit Vvaria;
Interface

   TYPE ST=STRING(.250.);

 (* Type   RGBRec=record
             RedVal,GreenVal,BlueVal:INTEGER;
           end;
       *)

    Var





        Rubrik           :ST;
        Bilnamn          :ST;
        CurDir           :ST;
        Spelar           :INTEGER;
 (*Allmnna variabler*)
        ch               :CHAR;
        p                :INTEGER;
        A                :REAL;
        x1,x2,x3,x4,x5   :INTEGER;     (*Reserv*)
        y1,y2            :INTEGER;     (*Reserv*)
        Re1,Re2,Re3,Re4  :REAL;        (*Reserv*)


(*Filhantering*)
        Tabe             :ST;
        Tabee            :ST;

(*Diverse*)
        Prog             :ST;          (*Anger vilket program som krs*)
        Exe              :CHAR;        (*S = programstart  G = Programkrning*)
        Screen           :REAL;        (*Skrmtyp*)
        Prespar          :STRING(.4.); (*Presentation och datalagring*)
        Bercykel         :LONGINT;     (*Berkningscykel nr*)
        Skalsp           :REAL;        (*Skala fr voltmeter*)
        Irel             :REAL;        (*Frhllande mellan begrd och verklig strm vid strmreduktion*)
        Myname           :ST;
        Ljud             :CHAR;
        TrspKod          :BYTE;

     (*Tider*)
        t                :REAL;        (*Krtid inom repetitionscykel*)
        t0               :REAL;        (*Reserv*)
        t00              :REAL;        (*Krtid vid start av upprepning*)
        ttot             :REAL;        (*Total krtid*)
        trel             :REAL;        (*Sluttid fr tidsperiod angiven relativt ttot*)
        Dt               :REAL;        (*Stllbart tidsinkrement*)
        Rt               :REAL;        (*Realtid sekunder*)
        Rt0              :REAL;        (*Realtid frra cykel sekunder*)
        Stoppad          :BOOLEAN;
     (*Strckor*)
        l                :REAL;        (*Krstrcka inom repetitionscykel*)
        l0               :REAL;        (*Krd vg till start av bensinfrbrukningsmtning*)
        l00              :REAL;        (*Krstrcka vid start av upprepning*)
        ltot             :REAL;        (*Totalt krd vg*)
        ltot0            :REAL;        (*Fregende vrde p totalt krd vg*)
        Hjd              :REAL;        (*Hjd ver utgngspunkt*)

     (*Hastigheter     Se Energiflde rrelse*)

     (*Batteristorheter*)
        Kp               :REAL;        (*Uttagen batterikapacitet i %*)
        Nomkap           :REAL;        (*Batteriets kapacitet enligt batteritabell*)
        Ladd             :CHAR;        (*Laddning till eller frn*)
        Laddman          :CHAR;        (*Anger manuel laddstyrning*)
        Laddngr0         :REAL;        (*Grns fr frnslag av laddning*)
        Laddngr1         :REAL;        (*Grns fr tillsl laddn*)
        Laddngr2         :REAL;        (*Grns fr tills laddn miljknsl*)
        kWh,kWh0,kWhut   :REAL;        (*Frn batteriet uttagen energi i kWh*)


        Noll             :REAL;
        Verknm           :REAL;         (*Verkningsgrad elmotor*)
        Verkng           :REAL;         (*Verkningsgrad generator*)


     (*Moder*)
        KmodI            :INTEGER;      (*Ny krmod*)
        KmodII           :INTEGER;      (*Frra krmod*)
        KmodIII          :INTEGER;      (*Krmod fre relativ tid*)
        Styrpdrag        :CHAR;         (*Pdragsmod*)
        Styrlut          :CHAR;         (*Lutningsmod*)
        Styrinkr         :CHAR;         (*Tidsinkrementmod*)
        Styromr          :CHAR;         (*Omrdesmod*)
        Cykeltyp         :CHAR;         (*Tidcykel eller karta*)
        Mber             :CHAR;         (*Typ av framdrivningsmotstndsberkning*)
        Drive            :INTEGER;      (*Krstil.Antal tidsinkr till beg hast*)
        DriveB           :INTEGER;      (*Bromsstil.Antal tidsinkr till beg hast*)

        ResDisk          :WORD;         (*Vald disk fr lagring av resultat*)

        Sber             :CHAR;         (*Mod fr korrigering av framdrivningsmotstnd*)

(*Variabler fr sifferpresentation i Ppres*)
        acc              :REAL;         (*Acceleration i dm/s2*)
        accp             :INTEGER;      (*Acceleration avrundad fr pres*)
        Ip               :INTEGER;      (*Visat strmvrde*)
        Up               :INTEGER;      (*Visat spnningsvrde*)
        Kpp              :INTEGER;      (*Visad batterikapacitet*)
        Bensinp          :INTEGER;      (*Visad bensinmngd*)
        COp              :INTEGER;      (*Visat CO-utslpp*)
        NOxp             :INTEGER;      (*Visat NOx-Utslpp*)
        HCp              :INTEGER;      (*Visat HC-utslpp*)
        bf               :REAL;         (*Bensinfrbrukning i dl/mil*)
        bfp              :INTEGER;      (*Bensinfrbrukning avrundad fr pres*)
        MaxIskal         :REAL;         (*Skalfaktor fr amperemeter*)

(*Tabeller och filer*)

        Fetchfil
                :ST;

        Bmapp,Mussfil
                :ST;
        Ttidd,Tkarta,Tbat,Tforb,Telm,Tford,Tpdr1,Tbr,Tvx (*Tabellnamn*)
                :ST;
        Tresultat,Tresultatp,Tjfr                        (*Namn p Resultatfiler*)
                :ST;
        Tr,Trp
                :CHAR;                                   (*Markr fr ppnade resultatfiler*)
        Infdir  :ST;                                     (*Directory fr hmtning av infiler*)

        Savefilnamn                                      (*Filnamn fr annat sparande av vrden n Sspara*)
                :ST;

        Resfil           :TEXT;
        Resfilp          :TEXT;
        Jfrfil           :FILE OF REAL;
        Savefil          :TEXT;
        Cykfil           :TEXT;                          (*Hmtning utan terppning i Ccykel-Tabr01*)
(*Konstanter*)
        MaxIelb,        (*Max motorstrm i elmod (Ladd = 0) *)
        MaxIhyb,        (*Max motorstrm vid hybriddrift (Ladd = +) *)
        Maxrpm,         (*Maxvarvtal*)
        MaxI,           (*Max motorstrm*)
        Massa,          (*Fordonsmassa i kg*)
        Nommassa,       (*Nominell fordonsmassa enligt tabell Tford*)
        CdA,            (*Cd gnger tvrsnittsyta*)
        Kap,            (*Batterikapacitet i Ah*)
        Iladd,          (*Laddningsstrm i A
                          Anvnds i Para1 som maxvrde fr gaspdrag*)
        Tank,           (*Bensintank i liter*)
        ngen,           (*Generatorvarvtal i rpm*)
        Minsp,          (*Minspnningsgrns*)
        Maxmel,         (*Maxmoment fr elmotor*)

        Fulltid,        (*Fulltid i sekunder*)
        Fulll,          (*Fullngd i m*)
        MaxFb,          (*Max bromskraft i N*)
        Skaldiff,       (*Skillnad i rullenergi i Ws/m vid avvikande massa*)
        SkalCdA,        (*Konstant fr omskalning av luftmotstnd*)
        Skaleff,        (*Konstant fr omskalning av effektpresentation*)
        Uelm,           (*Nominell spnning fr elmotor i V*)
        Relm,           (*Elmotorns resistans i ohm*)
        Throt,          (*Anvnds i Cconsk,Ppdrk och Tforb fr motorer med lngsamt pdrag*)
        Throttid        (*Anvnds i Ppdrk fr att lagra tidpunkt fr frra ndring*)
                                         :REAL;



(*Krcykelvrden*)
        Cy0,Cy1,Cy2,Cy3,Cy4,Cy5 :REAL;      (*Aktuella vrden frn KARTA eller TIDCYKEL*)
        Cyy0,Cyy1,Cyy2,Cyy3,Cyy4,Cyy5,CyNext  :REAL;
        Vny0,Vny1,Vny2,Vny3,Vny4,Vny5,
        Vold0,Vold1,Vold2,Vold3,Vold4,Vold5   :REAL;
        Oldcykfil                             :ST;

(*Omrdesstorheter*)
        Rs                  :BYTE;         (*Miljknsligt omrde*)
        Rs0                 :BYTE;         (*Fregende vrde p miljknsligt omrde*)
        Lutn                :REAL;         (*Lutning*)
        Lutn0               :REAL;         (*Fregende vrde p lutning*)
(* Energiflde allmnt*)
        Ia,Ia0,U,U0          :REAL;         (*Strm,spnning*)
        n,m,vx,Ppa            :REAL;         (*Varvtal,moment,utvxling,effekt*)
(*Energiflde IC-motor*)
        Iaic,Ia0ic,Uic,U0ic  :REAL;
        nic,mic,vxic,Ppic    :REAL;
        mmax                 :REAL;
        nic0,mic0,mmax0,
        Bbf0,PromCO,PromNO,
        PromHC               :LONGINT;
        Ystep                :REAL;        (*Momentsteg i musseldiagram*)
(*Energiflde elmotor*)
        Iael,Ia0el,Uel,U0el  :REAL;
        nel,mel,vxel,Ppel    :REAL;
        nbryt                :REAL;         (*Brytvarvtal fr elmaskin*)
(*Energiflde hjlpapparater*)
        Iahj,Ia0hj,Uhj,U0hj  :REAL;
        nhj,mhj,vxhj,Pphj    :REAL;
(*Bromsenergi*)
        Iabr,Ia0br,Ubr,U0br  :REAL;
        nbr,mbr,vxbr,Ppbr    :REAL;
(*Energiflde Batteri*)
        Iaba,Ia0ba,Uba,U0ba  :REAL;
        Uemk                 :REAL;         (*Tomgngsspnning batteri*)
        nba,mba,vxba,Ppba    :REAL;
(*Energiflde Laddning*)
        Ila,Ila0,Uladd,Ul0   :REAL;
        nladd,mladd,Ppladd   :REAL;

(*Energiflde kemiskt*)
        Bensin               :REAL;
        Bff                  :REAL;        (*Bensinfrbrukning i l/s*)
        Bbf                  :REAL;        (*Icmotorverkningsgrad i % *)
        Tankstopp            :CHAR;
        Burn                 :REAL;        (*Brnslets brnnvrde*)
        Dens                 :REAL;        (*Brnslets tthet*)
(*Energiflde rrelse*)
        vb                   :REAL;        (*Begrd hastighet*)
        vbb                  :REAL;         (*Begrd hastighet fr presentation*)
        vbIII                :REAL;        (*Begrd hastighet fre relativ tid*)
        v                    :REAL;        (*Verklig hastighet*)
        v0                   :REAL;        (*Verklig hastighet i fregende berkningscykel*)
        F,F0,F00             :REAL;
        Fb                   :REAL;        (*Bromskraft*)
        dm1,dm2              :REAL;        (*Svngmassa i systemet*)
        (*MaxFb se Konstanter*)
(*Avgas*)
        CO,NOx,HC            :REAL;
        CO0,NOx0,HC0         :REAL;        (*Vrden fr frra cykeln*)
        COr,NOxr,HCr         :REAL;
(*Vxelvrden*)

        vxlnr                :BYTE;       (*Vxelnummer*)
        vu        :ARRAY(.1..10.) OF REAL;(*Uppvxlingshastighet frn resp vxel i m/s*)
        vn        :ARRAY(.1..10.) OF REAL;(*Nedvxlingshastighet frn resp vxel i m/s*)
        vg        :ARRAY(.1..10.) OF REAL;(*Vxelverkningagrad i %*)
        vxx       :ARRAY(.1..10.) OF REAL;(*Utvxling m/s - rpm totalt*)
        bg        :ARRAY(.1..10.) OF REAL;(*Bakaxelverkningsgrad i %*)
        Gearmod   :INTEGER;               (*Vxelmod i Ggear*)

(*Presentation*)
        Strg,SS          :ST;

 (*Musseldiagram*)
        Xx,Yy            :INTEGER;
        Ymax             :REAL;

(*Tangentbord*)
        KeyCh            :CHAR;


        Vindruta         :CHAR;

(*Sidledsavvikelse*)

        Si1,Si2,SiD      :LONGINT;
        Si1r             :REAL;
        Sidmove          :CHAR;
        Sii              :LONGINT;
        lkurv            :REAL;


(*Bildlggning*)
        Px,Py                :INTEGER;
        pp,ppp,pppp,ptid     :INTEGER;
        Bildtyp              :ST;
        Bildfilnamn          :ST;
        BildData          :ARRAY(.1..128.) OF BYTE;
        Bildantal,Bildnr  :BYTE;


(*Pongberkning*)
        Event1,Event2,
        Event3,Event4,
        Event5,Event6    :INTEGER;

(*Vgens omgivning*)
        Omdetalj         :ARRAY(.0..100.) OF LONGINT; (*Anvnds enligt krcykelns modkolumn*)
        Omdetalj1        :ARRAY(.0..100.) OF LONGINT;
        Omdetalj2        :ARRAY(.0..100.) OF LONGINT; (*Anvnds fr egna bilder*)
        Omdetalj3        :ARRAY(.0..100.) OF LONGINT;
        Omdetalj4        :ARRAY(.0..100.) OF LONGINT;
        Omdetalj5        :ARRAY(.0..100.) OF LONGINT; (*Anvnds fr freteelser genererade i Ssikt
                                                      0 fr mtande bil,1 fr hghus*)
        (* Musstyrning*)
        Xmus,Ymus         :INTEGER;

        {Ljud}

  Ljudon:BOOLEAN;
  ljuda1:STRING;
  ljuda2:STRING;
  ljuda3:STRING;
  ljuda4:STRING;
  ljuda5:STRING;
  ljuda6:STRING;
  ljuda7:STRING;
  ljuda8:STRING;
  ljuda9:STRING;
  ljuda10:STRING;
  ljudlista:TEXT;
  ljudfilnamn:STRING;





 PROCEDURE Nolla;

Implementation

PROCEDURE Nolla;
  Begin

  Sii:=1;



(*Nollstll vrden *)
    Exe:='S';
    x1:=0;
    y1:=0;
    y2:=0;
    Re1:=0;
    Re2:=0;
    Re3:=0;
    Re4:=0;
    t:=0;
    t0:=0;
    t00:=0;
    ttot:=0;
    Dt:=1;
    l:=-1;
    l0:=0;
    l00:=0;
    ltot:=-1;

    Noll:=0;
    Ladd:='0';
    A:=0;

    Verknm:=50;
    Kp:=0.01;
    Lutn:=0;   (*Lutning i % *)
    CO:=0;
    COr:=0;
    NOx:=0;
    NOxr:=0;
    HC:=0;
    HCr:=0;
    Rs:=0;
    acc:=0;
    accp:=0;
    Ip:=0;
    Up:=0;
    Kpp:=0;
    Bensinp:=0;
    COp:=0;
    NOxp:=0;
    HCp:=0;
    bf:=0;
    bfp:=0;
    Ia:=0;
    Ia0:=0;
    U:=120;
    U0:=0;
    n:=0;
    m:=0;
    vx:=0;
    Pp:=0;
    Iaic:=0;
    Ia0ic:=0;
    Uic:=0;
    U0ic:=0;
    nic:=0;
    mic:=0;
    vxic:=0;
    Ppic:=0;
    Iael:=0;
    Ia0el:=0;
    Uel:=0;
    U0el:=0;
    nel:=0;
    mel:=0;
    vxel:=0;
    Ppel:=0;
    Iahj:=0;
    Ia0hj:=0;
    Uhj:=0;
    U0hj:=0;
    nhj:=0;
    mhj:=0;
    vxhj:=0;
    Pphj:=0;
    Iabr:=0;
    Ia0br:=0;
    Ubr:=0;
    U0br:=0;
    nbr:=0;
    mbr:=0;
    vxbr:=0;
    Ppbr:=0;
    Iaba:=0;
    Ia0ba:=0;
    Uba:=0;
    U0ba:=0;
    nba:=0;
    mba:=0;
    vxba:=0;
    Ppba:=0;
    Ila:=0;
    Ila0:=0;
    Uladd:=0;
    Ul0:=0;
    nladd:=0;
    mladd:=0;
    Ppladd:=0;
    Bensin:=Tank;
    vb:=0;
    vbIII:=0;
    v:=0;
    v0:=0;
    F:=0;
    F0:=0;
    F00:=0;
    Fb:=0;

    Styrpdrag:=' ';
    Styrlut:=' ';
    Styrinkr:=' ';
    Styromr:=' ';
    KmodI:=0;
    KmodII:=0;
    KmodIII:=0;
    Skaldiff:=0;
    Rt:=0;
    Rt0:=0;
    Bercykel:=0;
    trel:=0;
    mmax:=0;
    Infdir:='';
    CdA:=0;
    SkalCdA:=0;
    Drive:=1;
    DriveB:=1;
    Screen:=1;
    Bff:=0;
    Bbf:=0;
    Prespar:='0111';
    Uemk:=120;
    Skaleff:=1;
    ltot0:=0;
    SS:='';
    Strg:='';
    kWh:=0;
    kWh0:=0;
    kWhut:=0;
    Uelm:=120;
    Relm:=0;
    Irel:=1;
    MaxIelb:=0;
    MaxIhyb:=0;
    MaxIskal:=0;
    KeyCh:=' ';
    Vindruta:='J';
    Si1:=0;
    Si2:=0;
    SiD:=0;
    Si1:=0;
    Sidmove:='N';
    Tankstopp:='N';
    Cy0:=0;
    Cyy0:=0;
    Cy1:=0;
    Cyy1:=0;
    Cy2:=0;
    Cyy2:=0;
    Cy3:=0;
    Cyy3:=0;
    Cy4:=1;
    Cyy4:=1;
    Cy5:=0;
    Cyy5:=0;
    CyNext:=0.01;
    Vny0:=0;
    Vny1:=1;
    Vny2:=0;
    Vny3:=0;
    Vny4:=0;
    Vny5:=0;
    nic0:=0;
    mic0:=0;
    mmax0:=0;
    Bbf:=0;
    PromCO:=0;
    PromNO:=0;
    PromHC:=0;
    Event1:=0;
    Event2:=0;
    Event3:=0;
    Event4:=0;
    Event5:=0;
    Rs0:=0;
    For p:=0 to 100 do Omdetalj(.p.):=0;
    For p:=0 to 100 do Omdetalj1(.p.):=0;
    For p:=0 to 100 do Omdetalj2(.p.):=0;
    For p:=0 to 100 do Omdetalj3(.p.):=0;
    For p:=0 to 100 do Omdetalj4(.p.):=0;
    For p:=0 to 100 do Omdetalj5(.p.):=0;
    Gearmod:=20;
    Hjd:=0;
    Burn:=8.74;
    Ystep:=0;
    Maxrpm:=7000;
    Throt:=0;
    Throttid:=0;
    Dens:=0.75;
    Laddman:='0';
    Spelar:=0;
  End;


End.
